package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ast.FunctionalExpression;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.RawTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBindingVisitor;

class VisibilityInspector extends TypeBindingVisitor {
  private Scope scope;
  
  private boolean shouldChatter;
  
  private boolean visible = true;
  
  private FunctionalExpression expression;
  
  public VisibilityInspector(FunctionalExpression expression, Scope scope, boolean shouldChatter) {
    this.scope = scope;
    this.shouldChatter = shouldChatter;
    this.expression = expression;
  }
  
  private void checkVisibility(ReferenceBinding referenceBinding) {
    if (!referenceBinding.canBeSeenBy(this.scope)) {
      this.visible = false;
      if (this.shouldChatter)
        this.scope.problemReporter().descriptorHasInvisibleType(this.expression, referenceBinding); 
    } 
  }
  
  public boolean visit(ReferenceBinding referenceBinding) {
    checkVisibility(referenceBinding);
    return true;
  }
  
  public boolean visit(ParameterizedTypeBinding parameterizedTypeBinding) {
    checkVisibility((ReferenceBinding)parameterizedTypeBinding);
    return true;
  }
  
  public boolean visit(RawTypeBinding rawTypeBinding) {
    checkVisibility((ReferenceBinding)rawTypeBinding);
    return true;
  }
  
  public boolean visible(TypeBinding type) {
    TypeBindingVisitor.visit(this, type);
    return this.visible;
  }
  
  public boolean visible(TypeBinding[] types) {
    TypeBindingVisitor.visit(this, types);
    return this.visible;
  }
}
